.386
.Model Flat, StdCall
Option Casemap :None

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib

GROUPICON struct
;22 bytes
	Reserved1	WORD	?
	ResourceType	WORD	?
	ImageCount	WORD	?
	_Width		BYTE	?
	_Height		BYTE	?
	Colors		BYTE	?	
	Reserved2	BYTE	?
	Planes		WORD	?
	BitsPerPixel	WORD	?
	ImageSize	DWORD   ?
	ResourceID	WORD    ?
GROUPICON ends

.data   
	hFileIcon	dd 0
	hUpdateRes	dd 0
	dwFileIconSize	dd 0
	szTargetExe	db "test.exe",0
	szMyIcon	db "600.ico",0

.code

MAKELANGID proc usPrimaryLanguage:USHORT, usSubLanguage:USHORT

	movzx	eax, usPrimaryLanguage
	movzx	ebx, usSubLanguage
	shl	ebx, 10
	or	eax, ebx
	ret

MAKELANGID endp

InjectMainIcon proc uses ebx ecx edx esi edi lpExeFile:DWORD,lpMyIcon:DWORD
	LOCAL lpBuf		:DWORD
	LOCAL dwBytesTouched	:DWORD
	LOCAL grDate		:GROUPICON
	LOCAL LanguageId	:DWORD
	LOCAL lpBufSize_22	:DWORD
	
	invoke	BeginUpdateResource,lpExeFile,FALSE
	mov	hUpdateRes,eax
	
	invoke	CreateFile, lpMyIcon, GENERIC_READ,FILE_SHARE_READ, 0, OPEN_EXISTING, 0, 0
	test	eax,eax
	js	_exit
	mov	hFileIcon,eax
	
	invoke	GetFileSize, hFileIcon, 0
	mov	dwFileIconSize,eax
	
	invoke	GlobalAlloc,GPTR,dwFileIconSize
	mov	lpBuf,eax
	
	invoke	ReadFile,hFileIcon,lpBuf,dwFileIconSize,ADDR dwBytesTouched,0
	invoke	CloseHandle,hFileIcon

	invoke	MAKELANGID,LANG_ENGLISH,SUBLANG_DEFAULT
	mov	LanguageId,eax
	
	mov	ebx,lpBuf
	add	ebx,22;sizeof GROUPICON

	mov	edx,dwFileIconSize
	sub	edx,22;sizeof GROUPICON
	mov	lpBufSize_22,edx

	invoke	UpdateResource,hUpdateRes,RT_ICON,1,LanguageId,ebx,lpBufSize_22
	
	invoke	RtlZeroMemory,addr grDate,sizeof grDate
	
	mov	ax,1
	mov	grDate.ResourceType, ax
	mov	grDate.ImageCount,ax
	
	mov	al,32
	mov	grDate._Width,al
	mov	grDate._Height,al
	
	mov	ax,2
	mov	grDate.Planes,ax
	
	mov	ax,32
	mov	grDate.BitsPerPixel,ax
	
	push	lpBufSize_22
	pop	grDate.ImageSize
	
	mov	ax,1
	mov	grDate.ResourceID,ax

	invoke	UpdateResource,hUpdateRes,RT_GROUP_ICON,1,LanguageId,addr grDate,SIZEOF grDate

	invoke	EndUpdateResource,hUpdateRes,FALSE
	invoke	GlobalFree,lpBuf
_exit:
	ret
InjectMainIcon endp

start:
	invoke InjectMainIcon,addr szTargetExe,addr szMyIcon
	invoke ExitProcess, 0

end start